## openmodelica 24183

=== SimulationRuntime/c/CMakeLists.txt ===
# Jens Frenkel, Jens.Frenkel@tu-dresden.de, 2011-10-11
# CMakefile for compilation of OMC

# CMAKE
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

# PROJECT
PROJECT(SimulationRuntimeC)

# Global Variables
IF(NOT OMCTRUNCHOME)
  SET(OMCTRUNCHOME ${CMAKE_CURRENT_SOURCE_DIR}/../../)
ENDIF (NOT OMCTRUNCHOME)

# OMDEV PATH
IF(NOT OMDEV)
  SET(OMDEV $ENV{OMDEV})
ENDIF(NOT OMDEV)

INCLUDE_DIRECTORIES(${OMDEV}/lib/expat-win32-msvc ${OMDEV}/include/lis ${OMDEV}/include/pthread)
link_directories(${OMDEV}/lib/expat-win32-msvc)
link_directories(${OMDEV}/lib/lapack-win32-msvc)

# SUNDIALS Header
FIND_PATH(SUNDIALS_INCLUDE_DIR sundials/sundials_config.h /usr/include /usr/local/include $ENV{INCLUDE} ${OMDEV}/lib/3rdParty/Sundials/include)

# SUNDIALS Libraires
FIND_LIBRARY(SUNDIALS_LIBRARY_CVODE      NAMES sundials_cvode      PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/release/vc100)
FIND_LIBRARY(SUNDIALS_LIBRARY_IDA        NAMES sundials_ida        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/release/vc100)
FIND_LIBRARY(SUNDIALS_LIBRARY_NVEC       NAMES sundials_nvecserial        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/release/vc100)
FIND_LIBRARY(SUNDIALS_KINSOL       NAMES sundials_kinsol        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/release/vc100)

FIND_LIBRARY(SUNDIALS_LIBRARY_CVODED      NAMES sundials_cvoded      PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/debug/vc100)
FIND_LIBRARY(SUNDIALS_LIBRARY_IDAD        NAMES sundials_idad        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/debug/vc100)
FIND_LIBRARY(SUNDIALS_LIBRARY_NVECD       NAMES sundials_nvecseriald        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/debug/vc100)
FIND_LIBRARY(SUNDIALS_KINSOLD       NAMES sundials_kinsold        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/debug/vc100)

IF(SUNDIALS_INCLUDE_DIR)

  INCLUDE_DIRECTORIES(${SUNDIALS_INCLUDE_DIR})

  if(SUNDIALS_LIBRARY_CVODE AND
   SUNDIALS_LIBRARY_IDA AND
   SUNDIALS_LIBRARY_NVEC AND
   SUNDIALS_KINSOL)

  SET(SUNDIALS_LIBRARIES ${SUNDIALS_LIBRARY_CVODE} ${SUNDIALS_LIBRARY_IDA} ${SUNDIALS_LIBRARY_NVEC} ${SUNDIALS_KINSOL})

ENDIF(SUNDIALS_LIBRARY_CVODE AND
      SUNDIALS_LIBRARY_IDA AND
   SUNDIALS_LIBRARY_NVEC AND
   SUNDIALS_KINSOL)

  if(SUNDIALS_LIBRARY_CVODED AND
   SUNDIALS_LIBRARY_IDAD AND
   SUNDIALS_LIBRARY_NVECD AND
   SUNDIALS_KINSOLD)

  SET(SUNDIALS_DEBUG_LIBRARIES ${SUNDIALS_LIBRARY_CVODED} ${SUNDIALS_LIBRARY_IDAD} ${SUNDIALS_LIBRARY_NVECD} ${SUNDIALS_KINSOLD})

ENDIF(SUNDIALS_LIBRARY_CVODED AND
      SUNDIALS_LIBRARY_IDAD AND
   SUNDIALS_LIBRARY_NVECD AND
   SUNDIALS_KINSOLD)

ENDIF(SUNDIALS_INCLUDE_DIR)

# Defines for Visual Studio
if(MSVC)
	add_definitions(-D_CRT_SECURE_NO_WARNINGS -DNOMINMAX -D_COMPLEX_DEFINED)
    # GC shall not use a dll
    add_definitions(-DGC_NOT_DLL)
endif(MSVC)

# includes
INCLUDE_DIRECTORIES(${OMCTRUNCHOME})
INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/3rdParty/gc/include)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/linearization)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/math-support)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/meta)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/meta/gc)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simulation)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/optimization)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simulation/libf2c)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simulation/results)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simulation/solver)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simulation/solver/initialization)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/util)

# Subdirectorys
ADD_SUBDIRECTORY(math-support)
ADD_SUBDIRECTORY(meta)
ADD_SUBDIRECTORY(simulation)
ADD_SUBDIRECTORY(util)

# -------------------------------------------------------------
# MACRO definitions
# -------------------------------------------------------------

# Macros to hide/show cached variables.
# These two macros can be used to "hide" or "show" in the
# list of cached variables various variables and/or options
# that depend on other options.
# Note that once a variable is modified, it will preserve its
# value (hidding it merely makes it internal)

MACRO(HIDE_VARIABLE var)
  IF(DEFINED ${var})
    SET(${var} "${${var}}" CACHE INTERNAL "")
  ENDIF(DEFINED ${var})
ENDMACRO(HIDE_VARIABLE)

MACRO(SHOW_VARIABLE var type doc default)
  IF(DEFINED ${var})
    SET(${var} "${${var}}" CACHE "${type}" "${doc}" FORCE)
  ELSE(DEFINED ${var})
    SET(${var} "${default}" CACHE "${type}" "${doc}")
  ENDIF(DEFINED ${var})
ENDMACRO(SHOW_VARIABLE)

# MACRO BUILDMODEL
MACRO(BUILDMODEL model mo dir Flags CSRC)


  # includes
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/linearization)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/math-support)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/meta)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/meta/gc)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/libf2c)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/results)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/solver)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/solver/initialization)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/util)

  # OMDEV PATH
  IF(NOT OMDEV)
    SET(OMDEV $ENV{OMDEV})
  ENDIF(NOT OMDEV)

  INCLUDE_DIRECTORIES(${OMDEV}/lib/expat-win32-msvc)
  link_directories(${OMDEV}/lib/expat-win32-msvc)
  link_directories(${OMDEV}/lib/lapack-win32-msvc)

  # Variablen fuer openmodelica2sarturis
  SET(OMC_CODE   ${CMAKE_CURRENT_BINARY_DIR}/${model}.c
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.c
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_init.txt)
  SET(OMC_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${model}.c
  #               ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.cpp
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.h
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_records.c)

  # custom command fuer openmodelicacompiler
  ADD_CUSTOM_COMMAND(OUTPUT ${OMC_OUTPUT}
                     COMMAND ${OMC_DEBUG} ${Flags} +s ${dir}/${mo} Modelica ModelicaServices
                     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                     COMMENT "Erzeuge Code fuer ${model} with ${OMC_DEBUG}")

  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${model}codegen ALL DEPENDS ${OMC_OUTPUT})

  ADD_EXECUTABLE(${model} ${OMC_OUTPUT} ${CSRC})
  TARGET_LINK_LIBRARIES(${model} simulation util math-support results solver f2c meta ModelicaExternalC libexpat initialization lapack_win32_MT)

  # Dependencies
  ADD_DEPENDENCIES(${model} ${model}codegen)

  IF(MODELS_INSTALL)
    INSTALL(TARGETS ${model} RUNTIME DESTINATION ${MODELS_INSTALL_PATH})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${model}_init.txt DESTINATION ${MODELS_INSTALL_PATH})
  ENDIF(MODELS_INSTALL)
#ENDFOREACH(model ${model_sources})
ENDMACRO(BUILDMODEL)

# MACRO BUILDMODEL
MACRO(BUILDMODELMOS model mos dir Flags CSRC)

IF(WIN32)
  SET(COPY copy)
else(WIN32)
  SET(COPY cp)
endif(WIN32)

IF(SUNDIALS_INCLUDE_DIR AND
   SUNDIALS_LIBRARY_CVODE AND
   SUNDIALS_LIBRARY_IDA AND
   SUNDIALS_LIBRARY_NVEC AND
   SUNDIALS_KINSOL)

  INCLUDE_DIRECTORIES(${SUNDIALS_INCLUDE_DIR})
  SET(SUNDIALS_LIBRARIES ${SUNDIALS_LIBRARY_CVODE} ${SUNDIALS_LIBRARY_IDA} ${SUNDIALS_LIBRARY_NVEC} ${SUNDIALS_KINSOL})

ENDIF(SUNDIALS_INCLUDE_DIR AND
      SUNDIALS_LIBRARY_CVODE AND
      SUNDIALS_LIBRARY_IDA AND
   SUNDIALS_LIBRARY_NVEC AND
   SUNDIALS_KINSOL)

  # includes
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/linearization)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/math-support)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/meta)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/meta/gc)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/ModelicaExternalC)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/libf2c)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/results)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/solver)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/solver/initialization)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/util)

  INCLUDE_DIRECTORIES(${dir})

  # OMDEV PATH
  IF(NOT OMDEV)
    SET(OMDEV $ENV{OMDEV})
  ENDIF(NOT OMDEV)

  INCLUDE_DIRECTORIES(${OMDEV}/lib/expat-win32-msvc)
  link_directories(${OMDEV}/lib/expat-win32-msvc)
  link_directories(${OMDEV}/lib/lapack-win32-msvc)

  # custom command to copy expat.dll file
  SET(expat_CODE   ${OMDEV}/lib/expat-win32-msvc/libexpat.dll)
  STRING(REGEX REPLACE "/" "\\\\" expat_CODE_NEU ${expat_CODE})
  SET(expat_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/RelWithDebInfo/libexpat.dll)
  STRING(REGEX REPLACE "/" "\\\\" expat_OUTPUT_NEU ${expat_OUTPUT})

    ADD_CUSTOM_COMMAND(OUTPUT ${expat_OUTPUT}
                     COMMAND ${COPY} ${expat_CODE_NEU} ${expat_OUTPUT_NEU}
                     WORKING_DIRECTORY ${dir}
                     COMMENT "copy file ${expat_CODE_NEU} to ${expat_OUTPUT_NEU}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(expat${model} ALL DEPENDS ${expat_OUTPUT})


  SET(lapack_CODE   ${OMDEV}/lib/lapack-win32-msvc/lapack_win32_MT.dll)
  STRING(REGEX REPLACE "/" "\\\\" lapack_CODE_NEU ${lapack_CODE})
  SET(lapack_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/RelWithDebInfo/lapack_win32_MT.dll)
  STRING(REGEX REPLACE "/" "\\\\" lapack_OUTPUT_NEU ${lapack_OUTPUT})

  ADD_CUSTOM_COMMAND(OUTPUT ${lapack_OUTPUT} ${blas_OUTPUT} ${lapack_OUTPUT}
                     COMMAND ${COPY} ${lapack_CODE_NEU} ${lapack_OUTPUT_NEU}
                     WORKING_DIRECTORY ${dir}
                     COMMENT "copy file ${lapack_CODE_NEU} to ${lapack_OUTPUT_NEU}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(lapack${model} ALL DEPENDS ${lapack_OUTPUT})


  SET(blas_CODE   ${OMDEV}/lib/lapack-win32-msvc/blas_win32_MT.dll)
  STRING(REGEX REPLACE "/" "\\\\" blas_CODE_NEU ${blas_CODE})
  SET(blas_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/RelWithDebInfo/blas_win32_MT.dll)
  STRING(REGEX REPLACE "/" "\\\\" blas_OUTPUT_NEU ${blas_OUTPUT})

  ADD_CUSTOM_COMMAND(OUTPUT ${blas_OUTPUT} ${blas_OUTPUT} ${lapack_OUTPUT}
                     COMMAND ${COPY} ${blas_CODE_NEU} ${blas_OUTPUT_NEU}
                     WORKING_DIRECTORY ${dir}
                     COMMENT "copy file ${blas_CODE_NEU} to ${blas_OUTPUT_NEU}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(blas${model} ALL DEPENDS ${blas_OUTPUT})

  SET(OMC_MODELNAME ${model})
  # generate model.mos

  # Variablen fuer openmodelica2sarturis
  SET(OMC_CODE   ${dir}/${model}.c
                 ${dir}/${model}_functions.c
                 ${dir}/${model}_init.txt)
  SET(OMC_OUTPUT  ${dir}/${model}.c
  #                ${dir}/${model}_functions.cpp
				  ${dir}/${model}_functions.h
				  ${dir}/${model}_records.c)
  # custom command fuer openmodelicacompiler
  ADD_CUSTOM_COMMAND(OUTPUT ${OMC_OUTPUT}
                     COMMAND ${OMC_DEBUG} ${Flags} ${mos}
                     WORKING_DIRECTORY ${dir}
                     COMMENT "Generating code for ${model} with ${OMC_DEBUG}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${model}codegen ALL DEPENDS ${OMC_OUTPUT})

  ADD_CUSTOM_TARGET(${model}codegencpp ALL DEPENDS ${OMC_OUTPUT})

  ADD_DEFINITIONS(/TP)
  set_source_files_properties(${OMC_OUTPUT} PROPERTIES LANGUAGE CXX)
  ADD_EXECUTABLE(${model} ${OMC_OUTPUT} ${CSRC})

=== SimulationRuntime/cpp/CMakeLists.txt ===
# This script will build and install all required libraries of the C++ Simulation-runtime
#
# The following conditional defines are passed to the c++ compiler:
#     if the Boost_log and Boost_setup_log libraries were found        -DUSE_BOOST_LOG
#     if the Boost_thread library was found                            -DUSE_BOOST_THREAD
#     if the UMFPack library of SuiteSparse was found                  -DUSE_UMFPACK
#     if the PAPI library was found                                    -DUSE_PAPI
#     if the Sundials libraries were found                             -DPMC_USE_SUNDIALS
#     if the runtime is build for the OMC                              -DOMC_BUILD
#     if the write-output functionality should be handled in parallel  -DUSE_PARALLEL_OUTPUT
#     if ScoreP should be used for performance analysis                -DUSE_SCOREP
#     if the Intel TBB library was found                               -DUSE_INTEL_TBB
#     if the Pugi XML library was found                                -DUSE_PUGI_XML
#     if profiling for the simulation runtime should be enabled        -DRUNTIME_PROFILING
#
# Some of these options can be controlled by passing arguments to CMAKE 
#     if all libraries should be linked statically                     -DANALYZATION_MODE=ON
#     if write output should be handled in parallel                    -USE_PARALLEL_OUTPUT=ON
#     if ScoreP should be used for performance analysis                -USE_SCOREP=ON
#
#     Example: "cmake -DANALYZATION_MODE=ON -DCMAKE_BUILD_TYPE=RelWithDebInfo" to create statically linked libraries
#
# The used defines are stored in the SYSTEM_CFLAGS variable, which is passed to the ModelicaConfig.inc and written in the PrecompiledHeader.cmake

CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
PROJECT(CppSolverInterface)

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/CMake")

#Set Options
OPTION(ANALYZATION_MODE "ANALYZATION_MODE" OFF)
OPTION(USE_PARALLEL_OUTPUT "USE_PARALLEL_OUTPUT" OFF)
OPTION(USE_SCOREP "USE_SCOREP" OFF)
OPTION(RUNTIME_PROFILING "RUNTIME_PROFILING" OFF)
OPTION(SUNDIALS_ROOT "SUNDIALS ROOT" "")


#Set Variables
SET(MODELICAEXTERNALCDIR  "${CMAKE_SOURCE_DIR}/../../libraries/Resources/C-Sources")
SET(USERTABDIR  "${CMAKE_SOURCE_DIR}/../../libraries/Resources/Data/Tables")

SET(LIBINSTALLEXT "cpp")
SET(MODELICA_MODEL "ModelicaSystem")
SET(LIBPREFIX "OMCpp")
SET(SolverName ${LIBPREFIX}Solver)
SET(SystemName ${LIBPREFIX}System)
SET(OMCFactoryName ${LIBPREFIX}OMCFactory)
SET(MathName ${LIBPREFIX}Math)
SET(ModelicaExternalName ModelicaExternalC)
SET(ModelicaTablesName ModelicaStandardTables)
SET(SimulationSettings ${LIBPREFIX}SimulationSettings)
SET(SimControllerName ${LIBPREFIX}SimController)
SET(CVodeName ${LIBPREFIX}CVode)
SET(PeerName ${LIBPREFIX}Peer)
SET(RTRKName ${LIBPREFIX}RTRK)
SET(EulerName ${LIBPREFIX}Euler)
SET(IdaName ${LIBPREFIX}Ida)
SET(IdasName ${LIBPREFIX}Idas)
SET(KinsolName ${LIBPREFIX}Kinsol)
SET(ModelicaName ${LIBPREFIX}Modelica)
SET(NewtonName ${LIBPREFIX}Newton)
SET(HybrjName ${LIBPREFIX}Hybrj)
SET(UmfPackName ${LIBPREFIX}UmfPack)
SET(DataExchangeName ${LIBPREFIX}DataExchange)
SET(ModelicaUtilitiesName ${LIBPREFIX}ModelicaUtilities)
SET(ExtensionUtilitiesName ${LIBPREFIX}ExtensionUtilities)
SET(BasiLibName ${LIBPREFIX}Base)
SET(ModelicaCompilerName ${LIBPREFIX}ModelicaCompiler)

SET(USE_MICO OFF)
SET(REDUCE_DAE OFF)
SET(USE_SUNDIALS ON)
SET(OMC_BUILD ON)
SET(SIMSTER_BUILD OFF)

SET(Boost_USE_STATIC_LIBS OFF)
SET(Boost_USE_MULTITHREADED ON)
SET(Boost_USE_STATIC_RUNTIME OFF)

INCLUDE(${CMAKE_SOURCE_DIR}/PrecompiledHeader.cmake)

# Handle Analyzation mode
IF(NOT ANALYZATION_MODE)
  MESSAGE(STATUS "Analyzation mode disabled")
ELSE(NOT ANALYZATION_MODE)
  MESSAGE(STATUS "Using analyzation mode")
  ADD_DEFINITIONS(-DANALYZATION_MODE) 
ENDIF(NOT ANALYZATION_MODE )

# Handle parallel output
IF(USE_PARALLEL_OUTPUT)
  ADD_DEFINITIONS(-DUSE_PARALLEL_OUTPUT)
  MESSAGE(STATUS "Using parallel output")
ELSE(USE_PARALLEL_OUTPUT)
  MESSAGE(STATUS "Parallel output disabled")
ENDIF(USE_PARALLEL_OUTPUT)

# Handle ScoreP
IF(USE_SCOREP)
  ADD_DEFINITIONS(-DUSE_SCOREP)
  MESSAGE(STATUS "ScoreP enabled")
ELSE(USE_SCOREP)
  MESSAGE(STATUS "ScoreP disabled")
ENDIF(USE_SCOREP)

# Handle runtime profiling
IF(RUNTIME_PROFILING)
  ADD_DEFINITIONS(-DRUNTIME_PROFILING)
  MESSAGE(STATUS "Runtime profiling enabled")
ELSE(RUNTIME_PROFILING)
  MESSAGE(STATUS "Runtime profiling disabled")
ENDIF(RUNTIME_PROFILING)

# Handle build type
IF(OMC_BUILD)
  ADD_DEFINITIONS(-DOMC_BUILD)
ELSEIF(SIMSTER_BUILD)
  ADD_DEFINITIONS(-DSIMSTER_BUILD)
ENDIF(OMC_BUILD)


# Handle OMDEV
#  - On windows boost,blas,lapack and sundial solvers from omdev are used else the installed versions are used
IF(WIN32)
  SET(ENV{BOOST_ROOT} $ENV{OMDEV}"/lib/3rdParty/boost-1_55/")
  SET(BLAS_blas_LIBRARY $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/blas_win32.dll CACHE FILEPATH "Blas library")
  SET(LAPACK_lapack_LIBRARY  $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/lapack_win32.dll CACHE FILEPATH "Lapack library")
  SET(BLAS_DIRY "$ENV{OMDEV}/lib/3rdParty/Lapack/Lib/" CACHE LOCATION "where was yarp built?")

  # Disable Optimization for RelWithDebInfo on Windows
  IF(MSVC)
    STRING(REPLACE "/O2" "/Od" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
  ELSE(MSVC)
    STRING(REPLACE "/O2" "/O0" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
    STRING(REPLACE "/O2" "/O0" CMAKE_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
  ENDIF(MSVC)

  #set mico paths
  SET(MICO_LIB_HOME $ENV{OMDEV}/lib/mico-msys-mingw/)
  SET(MICO_INCLUDE_HOME  $ENV{OMDEV}/include/mico-msys-mingw/)
  #set sundials solvers include and library directories
  SET(SUNDIALS_INLCUDE_HOME  $ENV{OMDEV}/lib/3rdParty/Sundials/include)

  IF(MSVC)
    SET(SUNDIALS_LIBRARY_RELEASE_HOME  $ENV{OMDEV}/lib/3rdParty/Sundials/lib/release/vc100)
  ELSEIF(MINGW)
    SET(SUNDIALS_LIBRARY_RELEASE_HOME  $ENV{OMDEV}/lib/3rdParty/Sundials/lib/release/mingw/dlls)
  ENDIF(MSVC)
  
  SET(INSTALL_OMDEV_LIBS ON)
ENDIF(WIN32)


# Find CMinpack
# Note: Visual Studio libs are located in install/msvc, libs for gcc are directly in install
IF(MSVC)
    SET(CMinpack_Path "${CMAKE_SOURCE_DIR}/../../3rdParty/CMinpack/install/msvc")
ELSE(MSVC)
    SET(CMinpack_Path "${CMAKE_SOURCE_DIR}/../../3rdParty/CMinpack/install")
ENDIF(MSVC)

FIND_PATH(CMINPACK_INCLUDE_DIR cminpack.h
          HINTS ${CMinpack_Path}
          PATH_SUFFIXES include include/cminpack include/cminpack-1)

FIND_LIBRARY(CMINPACK_LIBRARY
             NAMES cminpack
             HINTS ${CMinpack_Path}
             PATH_SUFFIXES lib lib64)

INCLUDE_DIRECTORIES(${CMINPACK_INCLUDE_DIR})

# Find Intel TBB
FIND_PACKAGE(TBB)
IF(TBB_FOUND)
  ADD_DEFINITIONS(-DUSE_INTEL_TBB)
  MESSAGE (STATUS "Using Intel TBB")
ELSE(TBB_FOUND)
  MESSAGE (STATUS "Intel TBB disabled")
ENDIF(TBB_FOUND)

# Find Pugi XML
FIND_PACKAGE(PugiXML)
IF(PUGIXML_FOUND)
  ADD_DEFINITIONS(-DUSE_PUGI_XML)
  MESSAGE (STATUS "Using Pugi XML")
ELSE(PUGIXML_FOUND)
  MESSAGE (STATUS "Pugi XML disabled")
ENDIF(PUGIXML_FOUND)

# Find PAPI
FIND_LIBRARY(PAPI_LIBRARIES NAMES libpapi.a papi)
FIND_PATH(PAPI_INCLUDE_DIRS NAMES papi.h)
INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(PAPI DEFAULT_MSG PAPI_LIBRARIES PAPI_INCLUDE_DIRS)
IF(PAPI_FOUND)
  ADD_DEFINITIONS(-DUSE_PAPI)
ENDIF(PAPI_FOUND)


# Find Boost
#  - The optional boost libraries must be searched separately, otherwise no library is found if just one is missing.
#  - Additionaly the Boost_LIBRARIES variable is overwritten each time find_package(Boost ...) is called, thus it must be rescued
FIND_PACKAGE(Boost COMPONENTS log log_setup)

SET(Boost_LIBRARIES_TMP ${Boost_LIBRARIES_TMP} ${Boost_LIBRARIES})
IF(Boost_LOG_FOUND AND Boost_LOG_SETUP_FOUND)
  ADD_DEFINITIONS(-DUSE_BOOST_LOG)
  MESSAGE(STATUS "Using boost log")
ELSE(Boost_LOG_FOUND AND Boost_LOG_SETUP_FOUND)
  MESSAGE(STATUS "Boost log disabled")
  UNSET(Boost_LOG_LIBRARY)
ENDIF(Boost_LOG_FOUND AND Boost_LOG_SETUP_FOUND)

FIND_PACKAGE(Boost COMPONENTS thread atomic)

SET(Boost_LIBRARIES_TMP ${Boost_LIBRARIES_TMP} ${Boost_LIBRARIES})
FIND_PACKAGE(Threads)
IF(Boost_THREAD_FOUND AND Boost_ATOMIC_FOUND)
  ADD_DEFINITIONS(-DUSE_BOOST_THREAD)
  MESSAGE(STATUS "Using boost thread")
ELSE(Boost_THREAD_FOUND AND Boost_ATOMIC_FOUND)
  MESSAGE(STATUS "Boost thread disabled")
ENDIF(Boost_THREAD_FOUND AND Boost_ATOMIC_FOUND)

FIND_PACKAGE(Boost REQUIRED COMPONENTS filesystem system serialization program_options)
SET(Boost_LIBRARIES_TMP ${Boost_LIBRARIES_TMP} ${Boost_LIBRARIES})
SET(Boost_LIBRARIES ${Boost_LIBRARIES_TMP})
MESSAGE(STATUS "Boost Libraries")
MESSAGE(STATUS ${Boost_LIBRARIES})


# Find Lapack and Blas
FIND_PACKAGE(BLAS)
FIND_PACKAGE(LAPACK)

IF(MSVC)
  #workaround  because cmake does not find the lapack libraries for Visual Studio 10
  SET(LAPACK_MSVC_10  $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/lapack_win32.lib  )
  SET(BLAS_MSVC_10 $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/blas_win32.lib )
  SET(LAPACK_LIBRARIES  ${LAPACK_MSVC_10}   ${BLAS_MSVC_10} )

ELSEIF(MINGW)
  SET(LAPACK_MINGW  $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/lapack_win32.dll  )
  SET(BLAS_MINGW $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/blas_win32.dll )
  SET(LAPACK_LIBRARIES  ${LAPACK_MINGW}   ${BLAS_MINGW} )
ENDIF(MSVC)

FIND_LIBRARY(mkl_rt mkl_rt)
IF (mkl_rt)
  #workaround because find_package(lapack)-command returns the wrong libraries on Taurus (ZIH-TU Dresden)
  SET(LAPACK_LIBRARIES ${mkl_rt})
ENDIF(mkl_rt)

MESSAGE(STATUS "Lapack Libraries")
MESSAGE(STATUS ${LAPACK_LIBRARIES})


# Find Sundials solvers
IF(USE_SUNDIALS)
  FIND_PATH(SUNDIALS_INCLUDE_DIR cvode/cvode.h PATHS ${SUNDIALS_INLCUDE_HOME} $ENV{SUNDIALS_ROOT}/include)
  if (NOT SUNDIALS_INCLUDE_DIR)
      MESSAGE(FATAL_ERROR "Could not find Sundials, specify environment variable SUNDIALS_ROOT")
  ENDIF()
  MESSAGE(STATUS ${SUNDIALS_INCLUDE_DIR})

  FIND_LIBRARY(SUNDIALS_NVECSERIAL_LIB "sundials_nvecserial" PATHS ${SUNDIALS_LIBRARY_RELEASE_HOME} $ENV{SUNDIALS_ROOT}/lib)
  IF(NOT SUNDIALS_NVECSERIAL_LIB)
		MESSAGE(FATAL_ERROR "Could not find libsundials_nvecserial!")
  ENDIF()
  FIND_LIBRARY(SUNDIALS_CVODES_LIB "sundials_cvodes" PATHS ${SUNDIALS_LIBRARY_RELEASE_HOME}  $ENV{SUNDIALS_ROOT}/lib)
  IF(NOT SUNDIALS_CVODES_LIB)
		MESSAGE(FATAL_ERROR "Could not find libsundials_cvodes!")
  ENDIF()
  FIND_LIBRARY(SUNDIALS_IDA_LIB "sundials_ida" PATHS ${SUNDIALS_LIBRARY_RELEASE_HOME}  $ENV{SUNDIALS_ROOT}/lib)
  IF(NOT SUNDIALS_IDA_LIB)
		MESSAGE(FATAL_ERROR "Could not find libsundials_ida!")
  ENDIF()
  FIND_LIBRARY(SUNDIALS_KINSOL_LIB "sundials_kinsol" PATHS ${SUNDIALS_LIBRARY_RELEASE_HOME} $ENV{SUNDIALS_ROOT}/lib)
  IF(NOT SUNDIALS_KINSOL_LIB)
		MESSAGE(FATAL_ERROR "Could not find libsundials_kinsol!")
  ENDIF()
  #FIND_LIBRARY(SUNDIALS_IDAS_LIB "sundials_idas"
  #    PATHS ${SUNDIALS_LIBRARY_RELEASE_HOME} )

  SET(SUNDIALS_LIBS ${SUNDIALS_NVECSERIAL_LIB}  ${SUNDIALS_CVODES_LIB}  ${SUNDIALS_IDA_LIB}  ${SUNDIALS_KINSOL_LIB})

  MESSAGE(STATUS "Sundials Libraries:")
  MESSAGE(STATUS ${SUNDIALS_LIBS})
  ADD_DEFINITIONS(-DPMC_USE_SUNDIALS)

  # On Windows we need to install those libraries along with the SimManager
  INSTALL(FILES ${SUNDIALS_LIBS} DESTINATION bin)
ENDIF(USE_SUNDIALS)


#Handle umfpack
FIND_PACKAGE(SuiteSparse HINTS "${CMAKE_SOURCE_DIR}/Solver/UmfPack/")
IF(SuiteSparse_found)
  MESSAGE(STATUS "Using UmfPack")
  INCLUDE_DIRECTORIES(${SUITESPARSE_INCLUDE_DIRS})
  ADD_DEFINITIONS(-DUSE_UMFPACK)
    SET(SUITESPARSE_INCLUDE ${SUITESPARSE_INCLUDE_DIRS})
  SET(UMFPACK_LIB ${SUITESPARSE_LIBRARIES})
ELSE(SuiteSparse_found)
  MESSAGE(STATUS "UmfPack disabled")
  SET(SUITESPARSE_INCLUDE ".")
  SET(UMFPACK_LIB "")
ENDIF(SuiteSparse_found)


#Handle Mico corba
IF(USE_MICO)
  FIND_LIBRARY(MICO_LIBRARY  mico2313
    PATHS ${MICO_LIB_HOME}) #you can add additional search paths for mico library
  FIND_PATH(MICO_INCLUDE_DIR CORBA.h
     ${MICO_INCLUDE_HOME}) #you can add additional search paths for mico include
  MESSAGE(STATUS ${MICO_LIBRARY})

=== SimulationRuntime/cpp/Makefile ===
# Adrian Pop, adrpo@ida.liu.se, 2006-02-01
# Makefile for compilation of OMC using OMDev-mingw
# OMDev-mingw: http://www.ida.liu.se/~adrpo/omc/omdev/

top_builddir = ../../..
builddir_build=$(top_builddir)/build
builddir_bin=$(top_builddir)/build/bin
builddir_lib=$(top_builddir)/build/lib/omc
builddir_inc=$(top_builddir)/build/include/omc

ANALYZATION_MODE_COMMAND="-DANALYZATION_MODE=ON"
PARALLEL_OUTPUT_COMMAND="-DUSE_PARALLEL_OUTPUT=ON"
RUNTIME_PROFILING_COMMAND="-DRUNTIME_PROFILING=ON"
SCOREP_COMMAND="-DUSE_SCOREP=ON"
CMAKE_COMMANDS=CC="scorep --user --nocompiler --thread=pthread gcc" CXX="scorep --user --nocompiler --thread=pthread g++"

runtimeCpp: clean
ifneq ("$(ANALYZATION_MODE)","true")
	$(eval ANALYZATION_MODE_COMMAND=)
endif
ifneq ("$(USE_PARALLEL_OUTPUT)","true")
	$(eval PARALLEL_OUTPUT_COMMAND=)
endif
ifneq ("$(RUNTIME_PROFILING)","true")
	$(eval RUNTIME_PROFILING_COMMAND=)
endif
ifneq ("$(USE_SCOREP)","true") #If ScoreP ist used, the analyzation mode is automatically turned on
	$(eval CMAKE_COMMANDS=)
	$(eval SCOREP_COMMAND=)
else
	$(eval ANALYZATION_MODE_COMMAND="-DANALYZATION_MODE=ON")
endif
	cd ./Build && echo "change to Build" && $(CMAKE_COMMANDS) cmake $(ANALYZATION_MODE_COMMAND) $(PARALLEL_OUTPUT_COMMAND) $(RUNTIME_PROFILING_COMMAND) $(SCOREP_COMMAND) -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_INSTALL_PREFIX:PATH="$(builddir_build)"  ../
	$(MAKE) -C Build 

install: runtimeCpp
	(cd Build; $(MAKE) install)

clean:
	rm -R -f Build
	mkdir Build

=== SimulationRuntime/c/math-support/CMakeLists.txt ===
# Jens Frenkel, Jens.Frenkel@tu-dresden.de, 2011-10-11
# CMakefile for compilation of OMC

# Quellen und Header
SET(math_support_sources  bigden.c biglag.c dlamch.c lsame.c
                          nelmead.c newuoa.c newuob.c  pivot.c 
                          trsapp.c update.c)

SET(math_support_headers blaswrap.h)

# Library util
ADD_LIBRARY(math-support ${math_support_sources} ${math_support_headers})
#TARGET_LINK_LIBRARIES(util)

# Install
INSTALL(TARGETS math-support
		ARCHIVE DESTINATION lib/omc)

#INSTALL(FILES ${math_support_headers} DESTINATION include)

# add tests
#ADD_SUBDIRECTORY(test)

=== SimulationRuntime/c/util/CMakeLists.txt ===
# Quellen und Header
SET(util_sources  base_array.c boolean_array.c omc_error.c division.c index_spec.c
          integer_array.c java_interface.c libcsv.c list.c memory_pool.c modelica_string.c
          read_write.c read_matlab4.c read_csv.c real_array.c ringbuffer.c
          rtclock.c simulation_options.c string_array.c utility.c varinfo.c omc_msvc.c OldModelicaTables.c cJSON.o)


SET(util_headers  base_array.h boolean_array.h division.h omc_error.h index_spec.h integer_array.h
                  java_interface.h jni.h jni_md.h jni_md_solaris.h jni_md_windows.h list.h memory_pool.h
          modelica.h modelica_string.h read_write.h read_matlab4.h real_array.h
          ringbuffer.h rtclock.h simulation_options.h string_array.h utility.h varinfo.h)

if(MSVC)
    INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/3rdParty/regex-0.12)
    SET(util_sources ${util_sources} ${OMCTRUNCHOME}/3rdParty/regex-0.12/regex.c)
    SET(util_headers ${util_headers} ${OMCTRUNCHOME}/3rdParty/regex-0.12/regex.h)
endif(MSVC)

# Library util
ADD_LIBRARY(util ${util_sources} ${util_headers})
#TARGET_LINK_LIBRARIES(util)

# Install
INSTALL(TARGETS util
    ARCHIVE DESTINATION lib/omc)

#INSTALL(FILES ${util_headers} DESTINATION include)

=== SimulationRuntime/c/simulation/libf2c/Makefile ===
include makefile.u

=== SimulationRuntime/cpp/Core/Math/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(${MathName})
# add the solver default implementation library
IF(ANALYZATION_MODE)
	add_library(${MathName} STATIC ArrayOperations.cpp Functions.cpp SparseMatrix.cpp FactoryExport.cpp)
ELSE(ANALYZATION_MODE)
	add_library(${MathName} SHARED ArrayOperations.cpp Functions.cpp SparseMatrix.cpp FactoryExport.cpp)
ENDIF(ANALYZATION_MODE)

target_link_libraries (${MathName} ${Boost_LIBRARIES} ${SUITESPARSE_LIBRARIES} ${LAPACK_LIBRARIES})
if (UNIX)
set_target_properties(${MathName} PROPERTIES COMPILE_FLAGS -fPIC)
endif(UNIX)

install (TARGETS ${MathName} DESTINATION lib/omc/${LIBINSTALLEXT})

install (FILES ${CMAKE_SOURCE_DIR}/Include/Core/Math/Functions.h
          ${CMAKE_SOURCE_DIR}/Include/Core/Math/ArrayOperations.h
          ${CMAKE_SOURCE_DIR}/Include/Core/Math/Utility.h
          ${CMAKE_SOURCE_DIR}/Include/Core/Math/Constants.h
	  ${CMAKE_SOURCE_DIR}/Include/Core/Math/SparseMatrix.h
	  ${CMAKE_SOURCE_DIR}/Include/Core/Math/ILapack.h
          ${CMAKE_SOURCE_DIR}/Include/Core/Math/OMAPI.h
		   ${CMAKE_SOURCE_DIR}/Include/Core/Math/Array.h
         DESTINATION include/omc/cpp/Core/Math)

=== SimulationRuntime/cpp/Core/Modelica/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(${ModelicaName})

IF(ANALYZATION_MODE)
	add_library(${ModelicaName} STATIC Modelica.cpp ModelicaSystem.cpp  )
	include_directories(${SUNDIALS_INCLUDE_DIR}/cvodes ${SUNDIALS_INCLUDE_DIR}/nvector  ${SUNDIALS_INCLUDE_DIR}/sundials ${SUNDIALS_INCLUDE_DIR})
ELSE(ANALYZATION_MODE)
	add_library(${ModelicaName} SHARED Modelica.cpp ModelicaSystem.cpp   )
ENDIF(ANALYZATION_MODE)

target_link_libraries (${ModelicaName} ${ModelicaExternalCName}  ${SystemName} ${BaseName}  )


GET_TARGET_PROPERTY(libModelicaSystem ${ModelicaName} LOCATION)
GET_FILENAME_COMPONENT(libModelicaSystemNameExt ${libModelicaSystem} EXT)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  include(CheckTypeSize)
  check_type_size("void*" SIZEOF_VOID_P BUILTIN_TYPES_ONLY)
  set(LINUX_LIB_DL "-ldl")
  set(FPIC "-fPIC")
  if(${SIZEOF_VOID_P} MATCHES 8)
    set(FMI_ARCH_DIR "linux64")
  else(${SIZEOF_VOID_P} MATCHES 8)
    set(FMI_ARCH_DIR "linux32")
  endif(${SIZEOF_VOID_P} MATCHES 8)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  set(LINUX_LIB_DL "")
  set(FMI_ARCH_DIR "win32")
endif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

#GET_TARGET_PROPERTY(libboostSystem ${Boost_SYSTEM_LIBRARY} LOCATION)
#GET_FILENAME_COMPONENT(libboostSystemNAME ${libboostSystem} NAME)
#set(Boost_SYSTEM_LIBRARY_NAME ${libboostSystemNAME})

set (BOOST_INCLUDE ${Boost_INCLUDE_DIRS})
set (BOOST_LIBS ${Boost_LIBRARY_DIRS})
set (MODELICA_SYSTEM_LIB_EXT ${libModelicaSystemNameExt})

#Fix to enable debugging for gcc
#Problem: The ModelicaConfig.inc file contains something like "optimized;<lib>;debug;<lib>" if the debug or relwithdebinfo -flag is set. The gcc is not able to handle this after the linker-flag (-L).
#Quick Fix: Pick the debug libraries out of the list if the debug or relwithdebinfo -flag is set.
#Maybe someone with more cmake-experience can write a better solution for the issue.
#mwalther

list(GET Boost_SERIALIZATION_LIBRARY -1 Boost_SERIALIZATION_LIBRARY)
string(STRIP Boost_SERIALIZATION_LIBRARY ${Boost_SERIALIZATION_LIBRARY})
list(GET Boost_FILESYSTEM_LIBRARY -1 Boost_FILESYSTEM_LIBRARY)
string(STRIP Boost_FILESYSTEM_LIBRARY ${Boost_FILESYSTEM_LIBRARY})
list(GET Boost_SERIALIZATION_LIB -1 Boost_SERIALIZATION_LIB)
string(STRIP Boost_SERIALIZATION_LIB ${Boost_SERIALIZATION_LIB})
list(GET Boost_SYSTEM_LIBRARY -1 Boost_SYSTEM_LIBRARY)
string(STRIP Boost_SYSTEM_LIBRARY ${Boost_SYSTEM_LIBRARY})

IF(Boost_THREAD_LIBRARY)
list(GET Boost_THREAD_LIBRARY -1 Boost_THREAD_LIBRARY)
string(STRIP Boost_THREAD_LIBRARY ${Boost_THREAD_LIBRARY})
ENDIF(Boost_THREAD_LIBRARY)

list(GET Boost_PROGRAM_OPTIONS_LIBRARY -1 Boost_PROGRAM_OPTIONS_LIBRARY)
string(STRIP Boost_PROGRAM_OPTIONS_LIBRARY ${Boost_PROGRAM_OPTIONS_LIBRARY})

IF(Boost_LOG_LIBRARY)
list(GET Boost_LOG_LIBRARY -1 Boost_LOG_LIBRARY)
string(STRIP Boost_LOG_LIBRARY ${Boost_LOG_LIBRARY})
ENDIF(Boost_LOG_LIBRARY)

IF(CMAKE_BUILD_TYPE)
	string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
	set (Boost_LIBRARIES_NEW "")
	set (SKIP_ENTRY FALSE)

	IF(CMAKE_BUILD_TYPE MATCHES DEBUG)
		foreach(f ${Boost_LIBRARIES})
			IF(SKIP_ENTRY MATCHES FALSE)
				IF(${f} MATCHES "optimized")
					SET(${SKIP_ENTRY} TRUE)
				ELSEIF(${f} MATCHES "debug")
				
				ELSE(${f} MATCHES "optimized")
					LIST(APPEND Boost_LIBRARIES_NEW ${f})
				ENDIF(${f} MATCHES "optimized")
			ELSE(SKIP_ENTRY MATCHES FALSE)
				SET(${SKIP_ENTRY} FALSE)
			ENDIF(SKIP_ENTRY MATCHES FALSE)
		endforeach(f ${Boost_LIBRARIES})
	ELSEIF(CMAKE_BUILD_TYPE MATCHES RELWITHDEBINFO)
		foreach(f ${Boost_LIBRARIES})
			IF(SKIP_ENTRY MATCHES FALSE)
				IF(${f} MATCHES "optimized")
					SET(${SKIP_ENTRY} TRUE)
				ELSEIF(${f} MATCHES "debug")
				
				ELSE(${f} MATCHES "optimized")
					LIST(APPEND Boost_LIBRARIES_NEW ${f})
				ENDIF(${f} MATCHES "optimized")
			ELSE(SKIP_ENTRY MATCHES FALSE)
				SET(${SKIP_ENTRY} FALSE)
			ENDIF(SKIP_ENTRY MATCHES FALSE)
		endforeach(f ${Boost_LIBRARIES})
	ENDIF(CMAKE_BUILD_TYPE MATCHES DEBUG)

	set (Boost_LIBRARIES ${Boost_LIBRARIES_NEW})
ENDIF(CMAKE_BUILD_TYPE)

SET(SUNDIALS_LIBS_ "")
foreach(lib ${SUNDIALS_LIBS})
	set(SUNDIALS_LIBS_ "${SUNDIALS_LIBS_} ${lib}")
endforeach(lib ${SUNDIALS_LIBS})

SET(LAPACK_LIBRARIES_ "")
foreach(lib ${LAPACK_LIBRARIES})
	set(LAPACK_LIBRARIES_ "${LAPACK_LIBRARIES_} ${lib}")
endforeach(lib ${LAPACK_LIBRARIES})

SET(INTEL_TBB_LIBS "")
foreach(lib ${TBB_LIBRARIES})
	set(INTEL_TBB_LIBS "${INTEL_TBB_LIBS} ${lib}")
endforeach(lib ${TBB_LIBRARIES})

SET(UMFPACK_LIBS "")
foreach(lib ${UMFPACK_LIB})
	set(UMFPACK_LIBS "${UMFPACK_LIBS} ${lib}")
endforeach(lib ${UMFPACK_LIB})
#end Fix

add_precompiled_header(${ModelicaName} Include/Core/Modelica.h )

 configure_file (
  "ModelicaConfig.inc.in"
  "${PROJECT_BINARY_DIR}/ModelicaConfig.inc"
  )

configure_file (
 "ModelicaLibraryConfig.inc.in"
 "${PROJECT_BINARY_DIR}/ModelicaLibraryConfig.inc"
 )
 
install (FILES
				${PROJECT_BINARY_DIR}/ModelicaConfig.inc
				${PROJECT_BINARY_DIR}/ModelicaLibraryConfig.inc
				DESTINATION include/omc/cpp)


install (FILES  ${CMAKE_SOURCE_DIR}/Include/Core/HistoryImpl.h  ${CMAKE_SOURCE_DIR}/Include/Core/Modelica.h ${CMAKE_SOURCE_DIR}/Include/Core/ModelicaDefine.h DESTINATION include/omc/cpp/Core)
install (FILES  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/Policies/TextfileWriter.h DESTINATION include/omc/cpp/Core/DataExchange/Policies)
install (FILES  ${CMAKE_SOURCE_DIR}/Include/Core/DataExchange/Policies/MatfileWriter.h DESTINATION include/omc/cpp/Core/DataExchange/Policies)
#if(REDUCE_DAE)
#install (FILES Policies/BufferReaderWriter.h DESTINATION include/omc/cpp/policies)
#endif()

=== SimulationRuntime/cpp/Core/SimController/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(${SimControllerName})

IF(ANALYZATION_MODE)
	message(STATUS "Building SimController for analyzation")
	include_directories(${SUNDIALS_INCLUDE_DIR}/cvodes ${SUNDIALS_INCLUDE_DIR}/nvector  ${SUNDIALS_INCLUDE_DIR}/sundials ${SUNDIALS_INCLUDE_DIR}/kinsol ${SUNDIALS_INCLUDE_DIR})
	add_library(${SimControllerName} STATIC Configuration.cpp  FactoryExport.cpp Initialization.cpp SimController.cpp SimManager.cpp)
	target_link_libraries( ${SimControllerName} ${SystemName} ${OMCFactoryName} ${ExtensionUtilitiesName} ${Boost_LIBRARIES} ${CMAKE_DL_LIBS} )
ELSE(ANALYZATION_MODE)
	add_library(${SimControllerName} SHARED Configuration.cpp  FactoryExport.cpp Initialization.cpp SimController.cpp SimManager.cpp)
	target_link_libraries( ${SimControllerName} ${OMCFactoryName} ${ExtensionUtilitiesName} ${Boost_LIBRARIES} ${CMAKE_DL_LIBS} )
ENDIF(ANALYZATION_MODE)


install (TARGETS ${SimControllerName} DESTINATION lib/omc/${LIBINSTALLEXT})

install (FILES  ${CMAKE_SOURCE_DIR}/Include/Core/SimController/ISimData.h
                ${CMAKE_SOURCE_DIR}/Include/Core/SimController/ISimController.h
                ${CMAKE_SOURCE_DIR}/Include/Core/SimController/SimController.h
                ${CMAKE_SOURCE_DIR}/Include/Core/SimController/SimManager.h
      DESTINATION include/omc/cpp/Core/SimController)

IF(ANALYZATION_MODE)
	install (FILES  ${CMAKE_SOURCE_DIR}/Include/Core/SimController/SimController.h
	                ${CMAKE_SOURCE_DIR}/Include/Core/SimController/SimManager.h
	                ${CMAKE_SOURCE_DIR}/Include/Core/SimController/Configuration.h
	                ${CMAKE_SOURCE_DIR}/Include/Core/SimController/Initialization.h
	      DESTINATION include/omc/cpp/Core/SimController)
ENDIF(ANALYZATION_MODE)

=== SimulationRuntime/cpp/Core/SimulationSettings/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(${SimulationSettings})
# add the solver default implementation library
IF(ANALYZATION_MODE)
	include_directories(${SUNDIALS_INCLUDE_DIR}/cvodes ${SUNDIALS_INCLUDE_DIR}/nvector  ${SUNDIALS_INCLUDE_DIR}/sundials ${SUNDIALS_INCLUDE_DIR})
	add_library(${SimulationSettings} STATIC GlobalSettings.cpp Factory.cpp FactoryExport.cpp )
ELSE(ANALYZATION_MODE)
	add_library(${SimulationSettings} SHARED GlobalSettings.cpp Factory.cpp FactoryExport.cpp )
ENDIF(ANALYZATION_MODE)
target_link_libraries( ${SimulationSettings} ${OMCFactoryName} ${Boost_LIBRARIES})


install (TARGETS ${SimulationSettings} DESTINATION lib/omc/${LIBINSTALLEXT})
install (FILES "config/GlobalSettings.xml"
  DESTINATION share/omc/runtime/cpp/config)
install (FILES ${CMAKE_SOURCE_DIR}/Include/Core/SimulationSettings/IGlobalSettings.h
			   ${CMAKE_SOURCE_DIR}/Include/Core/SimulationSettings/ISettingsFactory.h
               ${CMAKE_SOURCE_DIR}/Include/Core/SimulationSettings/ISimControllerSettings.h
  DESTINATION include/omc/cpp/Core/SimulationSettings)

IF(ANALYZATION_MODE)
  install (FILES ${CMAKE_SOURCE_DIR}/Include/Core/SimulationSettings/Factory.h
  DESTINATION include/omc/cpp/Core/SimulationSettings)
ENDIF(ANALYZATION_MODE)

=== SimulationRuntime/cpp/Core/Solver/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(${SolverName})

# add the solver default implementation library
IF(ANALYZATION_MODE)
	message(STATUS "Building Solver for analyzation")
	include_directories(${SUNDIALS_INCLUDE_DIR}/cvodes ${SUNDIALS_INCLUDE_DIR}/nvector  ${SUNDIALS_INCLUDE_DIR}/sundials ${SUNDIALS_INCLUDE_DIR})
	add_library(${SolverName} STATIC SolverDefaultImplementation.cpp SolverSettings.cpp SystemStateSelection.cpp FactoryExport.cpp SimulationMonitor.cpp )
ELSE(ANALYZATION_MODE)
	add_library(${SolverName} SHARED SolverDefaultImplementation.cpp SolverSettings.cpp SystemStateSelection.cpp FactoryExport.cpp SimulationMonitor.cpp )
ENDIF(ANALYZATION_MODE)
target_link_libraries (${SolverName} ${MathName} ${Boost_LIBRARIES} ${ExtensionUtilitiesName})
install (TARGETS ${SolverName} DESTINATION lib/omc/${LIBINSTALLEXT})
install (FILES
         ${CMAKE_SOURCE_DIR}/Include/Core/Solver/IAlgLoopSolver.h 
         ${CMAKE_SOURCE_DIR}/Include/Core/Solver/ILinSolverSettings.h
         ${CMAKE_SOURCE_DIR}/Include/Core/Solver/INonLinSolverSettings.h
         ${CMAKE_SOURCE_DIR}/Include/Core/Solver/ISolver.h
         ${CMAKE_SOURCE_DIR}/Include/Core/Solver/ISolverSettings.h
DESTINATION include/omc/cpp/Core/Solver)

IF(ANALYZATION_MODE)
  install (FILES
         ${CMAKE_SOURCE_DIR}/Include/Core/Solver/SolverSettings.h 
         ${CMAKE_SOURCE_DIR}/Include/Core/Solver/SolverDefaultImplementation.h 
         ${CMAKE_SOURCE_DIR}/Include/Core/Solver/SystemStateSelection.h 
         ${CMAKE_SOURCE_DIR}/Include/Core/Solver/SimulationMonitor.h 
  DESTINATION include/omc/cpp/Core/Solver)
ENDIF(ANALYZATION_MODE)

=== SimulationRuntime/cpp/Core/System/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(${SystemName})
set(BASE_LIB "" CACHE INTERNAL "" )

#IF (NOT ((${CMAKE_SYSTEM_NAME} MATCHES "Darwin") OR  MSVC))
#add_library(${BasiLibName} STATIC tpl.cpp )
#set_target_properties(${BasiLibName} PROPERTIES COMPILE_FLAGS -fPIC)
#set(BASE_LIB -l${BasiLibName} CACHE INTERNAL "" )
#ENDIF (NOT ((${CMAKE_SYSTEM_NAME} MATCHES "Darwin") OR  MSVC))


# add the system default implementation library
IF(ANALYZATION_MODE)
	add_library(${SystemName} STATIC AlgLoopDefaultImplementation.cpp AlgLoopSolverFactory.cpp EventHandling.cpp SystemDefaultImplementation.cpp FactoryExport.cpp  )
	include_directories(${SUNDIALS_INCLUDE_DIR}/cvodes ${SUNDIALS_INCLUDE_DIR}/nvector  ${SUNDIALS_INCLUDE_DIR}/sundials ${SUNDIALS_INCLUDE_DIR}/kinsol ${SUNDIALS_INCLUDE_DIR})
	target_link_libraries (${SystemName} ${Boost_LIBRARIES} ${LAPACK_LIBRARIES} ${OMCFactoryName} )
    if (UNIX)
        set_target_properties(${SystemName} PROPERTIES COMPILE_FLAGS -fPIC)
    endif(UNIX)
ELSE(ANALYZATION_MODE)
	add_library(${SystemName} SHARED AlgLoopDefaultImplementation.cpp AlgLoopSolverFactory.cpp EventHandling.cpp DiscreteEvents.cpp ContinuousEvents.cpp SystemDefaultImplementation.cpp FactoryExport.cpp)
	target_link_libraries (${SystemName} ${Boost_LIBRARIES} ${LAPACK_LIBRARIES} ${OMCFactoryName} )
ENDIF(ANALYZATION_MODE)

# add a static library with the system default implementation for generating c++ fmu targets
add_library(${SystemName}_static STATIC AlgLoopDefaultImplementation.cpp AlgLoopSolverFactory.cpp EventHandling.cpp DiscreteEvents.cpp ContinuousEvents.cpp SystemDefaultImplementation.cpp )

target_link_libraries (${SystemName}_static ${Boost_LIBRARIES} ${LAPACK_LIBRARIES})
if (UNIX)
set_target_properties(${SystemName}_static PROPERTIES COMPILE_FLAGS -fPIC)
endif(UNIX)

install (TARGETS ${SystemName} DESTINATION lib/omc/${LIBINSTALLEXT})
install (TARGETS ${SystemName}_static DESTINATION lib/omc/${LIBINSTALLEXT})
#IF (NOT ((${CMAKE_SYSTEM_NAME} MATCHES "Darwin") OR  MSVC))
#install (TARGETS ${BasiLibName} DESTINATION lib/omc/${LIBINSTALLEXT})
#ENDIF (NOT ((${CMAKE_SYSTEM_NAME} MATCHES "Darwin") OR  MSVC))
install (FILES
	${CMAKE_SOURCE_DIR}/Include/Core/System/SystemDefaultImplementation.h
	${CMAKE_SOURCE_DIR}/Include/Core/System/AlgLoopDefaultImplementation.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/EventHandling.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/PreVariables.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/DiscreteEvents.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/ContinuousEvents.h
	DESTINATION include/omc/cpp/Core/System)
install (FILES
	${CMAKE_SOURCE_DIR}/Include/Core/System/IAlgLoop.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/IAlgLoopSolverFactory.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/AlgLoopSolverFactory.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/IContinuous.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/IMixedSystem.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/IEvent.h
		${CMAKE_SOURCE_DIR}/Include/Core/System/ITime.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/ISystemProperties.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/ISystemInitialization.h
        ${CMAKE_SOURCE_DIR}/Include/Core/System/IStepEvent.h
		${CMAKE_SOURCE_DIR}/Include/Core/System/IWriteOutput.h
		${CMAKE_SOURCE_DIR}/Include/Core/System/IStateSelection.h
      DESTINATION include/omc/cpp/Core/System)

=== debian/changelog ===
openmodelica (24183-1) unstable; urgency=low

  * Automatic subversion build
 -- OpenModelica Build System <build@openmodelica.org>  Sun, 25 Jan 2015 02:41:41 +0100

=== debian/control ===
Source: openmodelica
Section: math
Priority: optional
Maintainer: OpenModelica Build System <build@openmodelica.org>
Build-Depends: debhelper (>= 7.0.0),
 clang,
 automake,
 libtool,
 libncurses5-dev,
 libsqlite3-dev,
 cmake (>= 2.8.6),
 libssl-dev (>= 0.9.8g),
 libreadline-dev,
# ParadisEO requires this
 g++-4.4,
 gfortran,
 time,
 libqt4-dev (>= 4.4.3),
# Force libqtwebkit-dev when squeeze is removed
 libqtwebkit-dev | libqt4-dev (>= 4.4.3),
# libqwt-dev (>= 5.1.1) | libqwt5-qt4-dev (>= 5.1.1),
 liblpsolve55-dev (>= 5.5.0.10),
 openjdk-6-jdk | sun-java6-jdk,
 libomniorb4-dev,
 omniidl4 | omniidl (>= 4.0.0),
 omniidl4-python | omniidl-python,
 python-omniorb,
# precise doesn't handle hdf5 properly
 libhdf5-serial-dev | libhdf5-dev,
 libhwloc-dev,
 gnuplot,
 xsltproc,
 flex,
 paradiseo,
 bison,
 libf2c2-dev,
 liblapack-dev,
 autoconf,
 zip,
 unzip,
 libexpat1-dev,
 libsundials-serial-dev,
# Not in squeeze...
# libsundials-kinsol1,
 libgtkglext1-dev,
 libopenscenegraph-dev,
 libboost-all-dev,
 libdbus-1-dev
Standards-Version: 3.8.4

Package: openmodelica
Section: math
Architecture: any
Depends: omc,
 ompython,
 omplot,
 omlib-modelica-3.2.1,
 omshell,
 omshell-terminal,
 omnotebook,
 drmodelica,
 drcontrol,
 omedit,
 omoptim,
 ${misc:Depends}
Description: A complete Modelica environment
 The goal of the project is to create a complete Modelica modeling, compilation
 and simulation environment based on free software distributed in binary and
 source code form.
 .
 This package is a Debian metapackage. After installation this package can be
 removed. This metapackage pulls in the following OpenModelica packages:
 .
 1. Package omc the OpenModelica Compiler/Interpreter (omc)
 2. Package omshell the OpenModelica Shell (OMShell)
 3. Package omshell-terminal the OpenModelica Shell-terminal (OMShell-terminal)
 4. Package omlib-msl32 the Modelica Standard Library version 3.2.1
 5. Package omnotebook the OpenModelica Notebook, with DrModelica and DrControl
 6. Package omedit, a Modelica connection editor for OpenModelica
 7. Package omoptim, a tool for optimization of Modelica models
 8. Package omplot, the plot tools for OpenModelica

Package: omc
Section: math
Architecture: any
Depends: clang,
# sun-java6-jre | openjdk-6-jre, # Should no longer be needed
 build-essential,
 gnuplot,
 xsltproc,
 libf2c2-dev,
 libexpat1-dev,
 libsundials-serial-dev,
 liblapack-dev,
 zip,
 unzip,
 libdbus-1-dev,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: python-beautifulsoup,
 omplot,
 libsaxonb-java
Description: The OpenModelica Compiler
 This is the core of the OpenModelica project. It can be used stand-alone as
 a compiler. It is recommended to use it together with an OpenModelica client,
 such as OMShell (textual interface), OMNotebook (for teaching purposes)
 or OMEdit (graphical modeling).

Package: omc-bootstrapped
Section: math
Architecture: any
Priority: extra
Depends: omc,
 ${misc:Depends}
Description: omc-bootstrapped transitional dummy package
 This is a transitional dummy package. It has been replaced by package omc and can safely be removed.

Package: omc-doc
Section: math
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica manuals
 Contains large pdf-manuals for OpenModelica

Package: omc-java
Section: math
Architecture: any
Depends: omc, ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Java interface
 Contains jar-files to interface with OpenModelica

Package: omplot
Section: math
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Plot tool for OpenModelica
 This tool is essential for using the plot() command in omc.

Package: ompython
Section: math
Architecture: any
Depends: python-omniorb,
 python-pyparsing,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Python interface for OpenModelica
 A python CORBA interface for OpenModelica.

Package: omedit
Section: math
Architecture: any
Depends: omc,
 omlib-modelica-3.2.1,
 omlib-modelicareference,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A Modelica connection editor for OpenModelica
 OMEdit is still in active development. Please try it out and give feedback.

Package: omoptim
Section: math
Architecture: any
Depends: omc,
 gnuplot,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A Modelica optimization tool for OpenModelica

Package: omnotebook
Section: math
Architecture: any
Depends: omc,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: drmodelica,
 drcontrol
Description: A Mathematica-style Notebook for OpenModelica

Package: drmodelica
Section: math
Architecture: any
Depends: omnotebook,
 ${shlibs:Depends},
 ${misc:Depends}
Description: An OMNotebook course in the Modelica language
 The course is based on Peter Fritzson's book
 “Principles of Object-Oriented Modeling and Simulation with Modelica 2.1”.

Package: drcontrol
Section: math
Architecture: any
Depends: omnotebook,
 ${shlibs:Depends},
 ${misc:Depends}
Description: An OMNotebook course in basic control theory

Package: omshell-terminal
Section: math
Architecture: any
Depends: omc,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A text-based interface to OpenModelica (based on readline)

Package: omshell
Section: math
Architecture: any
Depends: omc,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A text-based interface to OpenModelica (based on Qt)

Package: libmodelica3d
Section: math
Architecture: any
Depends: omlib-modelicaservices-3.2.1-modelica3d,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A lightweight, platform-independent 3D-visualisation library for Modelica

Package: libomccpp
Section: math
Architecture: any
Depends: libboost-dev,
 libboost-filesystem-dev,
 libboost-system-dev,
 libboost-serialization-dev,
 libboost-program-options-dev,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Libraries for the C++ code generation target of OpenModelica

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# OpenModelica debian/rules that uses debhelper.
# Based on a sample file with GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ARCH ?= $(shell uname -m | sed s/i[0-9]86/x86/)

# Some variables to install binaries under debian/tmp
DEST   = $(CURDIR)/debian/tmp
SRCD   = $(CURDIR)

CLANGVER ?= $(shell clang --version | grep -o "clang version [0-9.]*" | cut "-d " -f3)

# Try to compile with gcc rather than old gcc versions
ifeq (3.0,$(CLANGVER))
	CC = gcc
	CXX = g++
else
	CC = clang
	CXX = clang++
endif

ifeq (arm-linux-gnueabihf,$(DEB_HOST_GNU_TYPE))
	CONF_OPTS=--disable-modelica3d
	EXTRA_INSTALL=fake_modelica3d
else
	CONF_OPTS=
	EXTRA_INSTALL=
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

#ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
#  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(shell grep -c ^processor /proc/cpuinfo)
#endif

# march=pentium4 used to be enabled because omc required sse2 regardless
# ifeq (x86,$(ARCH))
#        CFLAGS += -march=pentium4
# endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure.in
	autoconf

config.status: configure
	dh_testdir
	echo $(DEB_BUILD_OPTIONS)
	# Add here commands to configure the package.
	./configure CFLAGS="$(CFLAGS)" CC=$(CC) CXX=$(CXX) OMPCC="gcc -fopenmp" \
	--host=$(DEB_HOST_GNU_TYPE) \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--prefix=/usr \
	--with-lapack="-llapack -lblas" \
	--with-omniORB=/usr \
	--without-ipopt \
	$(CONF_OPTS)
#       --with-static-sqlite=`test -f /usr/lib/*/libsqlite3.a && echo /usr/lib/*/libsqlite3.a || echo /usr/lib/libsqlite3.a` \
#	--with-static-lpsolve=/usr
#	--with-static-readline=/usr

build: build-stamp

build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) $(MAKEFLAGS) NOLIBRARIES=Yes release mosh omlibrary qtclients
	$(MAKE) $(MAKEFLAGS) NOLIBRARIES=Yes runtimeCPPinstall
	mv build/bin/omc build/bin/omc-bootstrapped
	# Qtclients will start make omc again
	# This is a good thing as Susan will then run and regenerate SimCodeC
	# Skip it due to ModelicaBuiltin not existing
	# $(MAKE) release
	# Skip the testsuite log. People can look it up on hudson
	# bash -c "(ulimit -t 600 && cd testsuite/partest && /usr/bin/time -f '== Testsuite wall-time: %e' ./runtests.pl -nocolour)" > ./build/share/doc/omc/testsuite.txt 2>&1
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	# Add here commands to clean up after the build process.
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs -popenmodelica -Pdebian/tmp
	# Add here commands to install the package into debian/tmp.
	$(MAKE) $(MAKEFLAGS) install $(EXTRA_INSTALL) DESTDIR=$(DEST)
	# We add our own Debian-specific copyright file
	rm -f $(DEST)/usr/share/doc/omc/COPYING
	dh_install

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_install
	dh_installmenu
	dh_installmime
	dh_installman
	dh_link
	dh_strip
	# dh_compress -X.pdf -X.onb -X.c -X.h -X.mo -X.mos -Xomc_helptext.txt -X.py
	dh_fixperms
	dh_installdeb
	dh_makeshlibs -V
	dh_shlibdeps -l/usr/lib/omc -Lomc -- --ignore-missing-info
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
